## OOo/pyuno - introspekacja
#

# wyciagniete z ~/tcl/mh_lib.tcl
proc iterate {zm liIter kod} {
  # catch: 0 ok, 1 error, 2 return, 3 break, 4 continue
  upvar $zm i
  for {set i 0} {$i<$liIter} {incr i} {
    set e [catch {uplevel $kod} x]
    if {$e==3} {return $x}
    if {$e==1 || $e==2} {return -code $e $x}
  }
}
proc iterate1 {zm liIter kod} {
  upvar $zm i
  for {set i 1} {$i<=$liIter} {incr i} {
    set e [catch {uplevel $kod} x]
    if {$e==3} {return $x}
    if {$e==1 || $e==2} {return -code $e $x}
  }
}

# proc pyunoObjInfo wyciaga z ob. pyuno serwisy, interfejsy
proc pyunoObjInfo o {
  set _ {}
  set x1 [py $o]
  regexp {^pyuno object \((.*)\)[0-9a-fx]+\{(.*)\}} $x1 x1a x1b x1c; set x1c
  lappend _ $x1b
  set x2 [string range [lindex $x1c 1] 0 end-1]
  regexp {^supportedServices=\{(.*)\}} $x2 x2a x2b
  lappend _ [split $x2b ,]
  set x3 [string range [lindex $x1c 2] 0 end]
  regexp {^supportedInterfaces=\{(.*)\}} $x3 x3a x3b
  lappend _ [split $x3b ,]
}
proc pyunoObjInfoPrint o {
  set q1 [pyunoObjInfo $o]
  set _ ""
  append _ "[lindex $q1 0]\n"
  append _ "services:\n[join [lindex $q1 1] \n]\n"
  append _ "interfaces:\n[join [lindex $q1 2] \n]\n"
  return $_
}

# proc interfInfo wyswietla metody interfejsu
# proc interfInfoForService wyswietla metody wszystkich interf. serwisu
# + musi istniec zmienna tcl_cr !!!
proc ootrim s {return [string range $s 2 end-1]}
py {tcl_cr= smgr.createInstance("com.sun.star.reflection.CoreReflection")}
proc interfInfo x {
  set _ ""
  py {__z1= "???"; __z2="???"}
  py "__z1= tcl_cr.forName(\"$x\")"
  py {__z2= __z1.getMethods()}
  iterate i [py len(__z2)] {
    append _ "[ootrim [py "__z2\[$i\].getReturnType().getName()"]] "
    append _ "[ootrim [py "__z2\[$i\].getName()"]] "
    py "__z3= __z2\[$i\].getParameterTypes()"
    iterate j [py len(__z3)] {
      append _ "[ootrim [py "__z3\[$j\].getName()"]], "
    }
    if {[string range $_ end-1 end]==", "} {set _ "[string range $_ 0 end-2]"}
    append _ \n
  }
  set _
}
proc interfInfoForService o {
  set q1 [pyunoObjInfo $o]
  set _ ""
  foreach x [lindex $q1 2] {
    append _ "--- $x\n[interfInfo $x]"
  }
  set _
}

proc serviceProps s {
  py "__q1= $s.getPropertySetInfo().getProperties()"
  set len [py len(__q1)]
  set _ {}
  iterate i $len {
    lappend _ [list [ootrim [py "__q1\[$i\].Name"]] [lindex [py "__q1\[$i\].Type"] 2]]
  }
  join [lsort -index 0 $_] \n
}

proc poi o {pyunoObjInfoPrint $o}
proc ii o {interfInfo $o}
proc sp o {serviceProps $o}

